%
% $Id: ns_xtt.cpp,v 1.17 2010-01-06 08:07:59 kinio Exp $
%
% File generated by HeKatE Qt Editor ver. M6_10
%
% HeaRT case
%
%
%     Copyright (C) 2006-9 by the HeKatE Project
%
%     HeaRT has been develped by the HeKatE Project, 
%     see http://hekate.ia.agh.edu.pl
%
%     This file is part of HeaRT.
%
%     HeaRT is free software: you can redistribute it and/or modify
%     it under the terms of the GNU General Public License as published by
%     the Free Software Foundation, either version 3 of the License, or
%     (at your option) any later version.
%
%     HeaRT is distributed in the hope that it will be useful,
%     but WITHOUT ANY WARRANTY; without even the implied warranty of
%     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
%     GNU General Public License for more details.
%
%     You should have received a copy of the GNU General Public License
%     along with HeaRT.  If not, see <http://www.gnu.org/licenses/>.
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

:- ensure_loaded('heart.pl').

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% TYPES DEFINITIONS %%%%%%%%%%%%%%%%%%%%%%%%%%

xtype [name: boolean,
       base: numeric,
       length: 1,
       scale: 0,
       desc: boolean,
       domain: [0,1]
      ].
xtype [name: integer,
       base: numeric,
       length: 10,
       scale: 0,
       desc: integer,
       domain: [-2147483648 to 2147483647]
      ].


xtype [name: age_t,
       base: numeric,
       domain: [1.000 to 100.000]
      ].
xtype [name: genres,
       base: symbolic,
       domain: [horror,science,handbook,fantasy,poetry,historical]
      ].
xtype [name: titles_hb,
       base: symbolic,
       domain: ['Betty Crocker Christmas Cookbook','Logical Foundations for Rule-Based Systems','The Christmas Table']
      ].
xtype [name: titles_hr,
       base: symbolic,
       domain: ['At the mountains of madness','Desperation','Insomnia','It','The call of Cthulhu']
      ].
xtype [name: titles_sc,
       base: symbolic,
       domain: ['Logical Foundations for Rule-Based Systems']
      ].
xtype [name: age_selection,
       base: symbolic,
       domain: [young_sf,adult_sf,young_poetry,adult_poetry,young_thrillers,young_horrors,none,all_science,adult_horrors,adult_thrillers,handbooks,adult_handbooks,horrors]
      ].
xtype [name: titles,
       base: symbolic,
       domain: ['At the mountains of madness','Bag of bones','Betty Crocker Christmas Cookbook','Desperation','Insomnia','It','Logical Foundations for RBS','The call of Cthulhu','The Christmas Table','The Raven and Other Poems']
      ].
xtype [name: languages,
       base: symbolic,
       domain: [polish,english,german,spanish,greek,italian,hebrew]
      ].

%%%%%%%%%%%%%%%%%%%%%%%%% ATTRIBUTES DEFINITIONS %%%%%%%%%%%%%%%%%%%%%%%%%%

xattr [name: age,
       abbrev: age,
       class: simple,
       type: age_t,
       comm: in
      ].
xattr [name: '{age_filter}',
       abbrev: '{age1}',
       class: general,
       type: age_selection,
       comm: inter
      ].
xattr [name: '{comedy_movies}',
       abbrev: '{com1}',
       class: general,
       type: titles_sc,
       comm: out
      ].
xattr [name: '{fav_genres}',
       abbrev: '{fav1}',
       class: general,
       type: genres,
       comm: in
      ].
xattr [name: '{horror_movies}',
       abbrev: '{hor1}',
       class: general,
       type: numeric,
       comm: out
      ].
xattr [name: '{known_languages}',
       abbrev: '{kno1}',
       class: general,
       type: languages,
       comm: inter
      ].
xattr [name: '{recently_read_filter}',
       abbrev: '{rec1}',
       class: general,
       type: titles,
       comm: inter
      ].
xattr [name: '{recently_read}',
       abbrev: '{rec1}',
       class: general,
       type: titles,
       comm: inter,
       desc: 'Recently read book'
      ].
xattr [name: '{recommended_books}',
       abbrev: '{rec1}',
       class: general,
       type: titles,
       comm: inter,
       desc: 'all the books from the bookstore'
      ].
xattr [name: '{sf_movies}',
       abbrev: '{sf}',
       class: general,
       type: titles_hb,
       comm: out
      ].
xattr [name: '{thriller_movies}',
       abbrev: '{thr1}',
       class: general,
       type: titles_hr,
       comm: out
      ].

%%%%%%%%%%%%%%%%%%%%%%%% TABLE SCHEMAS DEFINITIONS %%%%%%%%%%%%%%%%%%%%%%%%

xschm age_filter: [age,'{fav_genres}'] ==> ['{age_filter}'].
xschm recommend_books: ['{age_filter}','{recently_read_filter}','{known_languages}'] ==> ['{recommended_books}'].
xschm recently_read: ['{recently_read}'] ==> ['{recently_read_filter}'].

%%%%%%%%%%%%%%%%%%%%%%%%%%%% RULES DEFINITIONS %%%%%%%%%%%%%%%%%%%%%%%%%%%%

xrule age_filter/1:
      [age lt 18.000,
       '{fav_genres}' eq horror]
    ==>
      ['{age_filter}' set [young_horrors]]
    :recommend_books.
xrule age_filter/2:
      [age lt 18.000,
       '{fav_genres}' eq poetry]
    ==>
      ['{age_filter}' set [young_poetry]].
xrule age_filter/3:
      [age in [18.000 to 100.000],
       '{fav_genres}' eq horror]
    ==>
      ['{age_filter}' set [adult_horrors]]
    :recommend_books/5.
xrule age_filter/4:
      [age in [18.000 to 100.000],
       '{fav_genres}' eq handbook]
    ==>
      ['{age_filter}' set [adult_handbooks]]
    :recommend_books/2.
xrule age_filter/5:
      [age lt 18.000,
       '{fav_genres}' eq any]
    ==>
      ['{age_filter}' set [young_poetry,young_horrors,all_science]]
    :recommend_books.
xrule age_filter/6:
      [age in [18.000 to 100.000],
       '{fav_genres}' eq poetry]
    ==>
      ['{age_filter}' set [adult_poetry]]
    :recommend_books.
xrule age_filter/7:
      [age in [any],
       '{fav_genres}' in [science]]
    ==>
      ['{age_filter}' set [all_science]].

xrule recommend_books/1:
      ['{age_filter}' in [young_horrors,adult_horrors],
       '{recently_read_filter}' in [any],
       '{known_languages}' in [any]]
    ==>
      ['{recommended_books}' set ['The call of Cthulhu']].
xrule recommend_books/2:
      ['{age_filter}' in [any],
       '{recently_read_filter}' eq 'It',
       '{known_languages}' eq english]
    ==>
      ['{recommended_books}' set ['It']].
xrule recommend_books/1:
      ['{age_filter}' in [all_science],
       '{recently_read_filter}' in [any],
       '{known_languages}' in [polish,english]]
    ==>
      ['{recommended_books}' set ['Logical Foundations for RBS']].
xrule recommend_books/2:
      ['{age_filter}' eq handbooks,
       '{recently_read_filter}' in [any],
       '{known_languages}' in [any]]
    ==>
      ['{recommended_books}' set ['The Christmas Table']].
xrule recommend_books/5:
      ['{age_filter}' sim [adult_poetry,horrors],
       '{recently_read_filter}' in [any],
       '{known_languages}' eq english]
    ==>
      ['{recommended_books}' set ['The Raven and Other Poems']].

xrule recently_read/1:
      ['{recently_read}' eq 'The call of Cthulhu']
    ==>
      ['{recently_read_filter}' set ['At the mountains of madness']]
    :recommend_books.
xrule recently_read/2:
      ['{recently_read}' in ['Desperation']]
    ==>
      ['{recently_read_filter}' set ['Insomnia','It']]
    :recommend_books/2.
xrule recently_read/1:
      ['{recently_read}' in ['The Christmas Table']]
    ==>
      ['{recently_read_filter}' set ['Betty Crocker Christmas Cookbook']]
    :recommend_books.


%%%%%%%%%%%%%%%%%%%%%%%%% STATES DEFINITIONS %%%%%%%%%%%%%%%%%%%%%%%%%%


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% File generated by HeKatE Qt Editor ver. M6_10
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%