%-- eq ------------------------------------------------------------------------%
join(Attr eq Value, Attr in NValueSet) :- 
  alsv_attr_class(Attr,simple), 
  vnormalize(Attr,[Value],[NValue]), 
  j(Attr eq Value2),
  vnormalize(Attr,[Value2],[NValue2]),
  appendDistinct([NValue], [NValue2], NValueSet), !.
  
join(Attr eq Value, Attr in NValueSet) :- 
  alsv_attr_class(Attr,simple), 
  vnormalize(Attr,[Value],[NValue]), 
  j(Attr neq Value2),
  vcomplement(Attr, [Value2], NVCSet),
  appendDistinct([NValue], NVCSet, NValueSet), !.
  
join(Attr eq Value, Attr in NValueSet) :- 
  alsv_attr_class(Attr,simple), 
  vnormalize(Attr,[Value],[NValue]),
  j(Attr in ValueSet), 
  vnormalize(Attr,ValueSet,NValueSet2),
  appendDistinct([NValue], NValueSet2, NValueSet), !.

join(Attr eq Value, Attr notin NValueSet) :- 
  alsv_attr_class(Attr,simple), 
  vnormalize(Attr,[Value],[NValue]),
  j(Attr notin ValueSet), 
  vcomplement(Attr, ValueSet, NVCSet),
  appendDistinct([NValue], NVCSet, NValueSet), !.
  
%-- neq -----------------------------------------------------------------------%
join(Attr neq Value, Attr in NValueSet) :- 
  alsv_attr_class(Attr,simple), 
  vcomplement(Attr, [Value], NVCSet1),
  j(Attr neq Value2),
  vcomplement(Attr, [Value2], NVCSet2),
  appendDistinct(NVCSet1, NVCSet2, NValueSet), !.
  
join(Attr neq Value, Attr in NValueSet) :- 
  alsv_attr_class(Attr,simple), 
  vcomplement(Attr, [Value], NVCSet1),
  j(Attr in ValueSet), 
  vnormalize(Attr,ValueSet,NValueSet2),
  appendDistinct(NVCSet1, NValueSet2, NValueSet), !.

join(Attr neq Value, Attr notin NValueSet) :- 
  alsv_attr_class(Attr,simple), 
  vcomplement(Attr, [Value], NVCSet1),
  j(Attr notin ValueSet), 
  vcomplement(Attr, ValueSet, NVCSet2),
  appendDistinct(NVCSet1, NVCSet2, NValueSet), !.
  
%-- in ------------------------------------------------------------------------%
join(Attr in VSet, Attr in NValueSet) :- 
  alsv_attr_class(Attr,simple), 
  vnormalize(Attr,VSet,NVSet),
  j(Attr in WSet), 
  vnormalize(Attr,WSet,NWSet),
  appendDistinct(NVSet, NWSet, NValueSet), !.

join(Attr in VSet, Attr in NValueSet) :- 
  alsv_attr_class(Attr,simple), 
  vnormalize(Attr,VSet,NVSet),
  j(Attr notin WSet), 
  vcomplement(Attr, WSet, NWCSet),
  appendDistinct(NVSet, NWCSet, NValueSet), !.
  
%-- notin ---------------------------------------------------------------------%
join(Attr notin VSet, Attr notin NValueSet) :- 
  alsv_attr_class(Attr,simple), 
  vcomplement(Attr, VSet, NVCSet),
  j(Attr notin WSet), 
  vcomplement(Attr, WSet, NWCSet),
  appendDistinct(NVCSet, NWCSet, NValueSet), !.