%
% $Id: therm-rt.pl,v 1.2 2009-05-24 17:57:20 aligeza Exp $
%
% Copyright 2004-9 by Grzegorz J. Nalepa and A. Ligeza
%
% HeaRT thermostat case
%
%
%     Copyright (C) 2004-6 by A. Ligeza, G. J. Nalepa
%     Copyright (C) 2006-9 by the HeKatE Project
%
%     HeaRT has been develped by the HeKatE Project, 
%     see http://hekate.ia.agh.edu.pl
%
%     This file is part of HeaRT.
%
%     HeaRT is free software: you can redistribute it and/or modify
%     it under the terms of the GNU General Public License as published by
%     the Free Software Foundation, either version 3 of the License, or
%     (at your option) any later version.
%
%     HeaRT is distributed in the hope that it will be useful,
%     but WITHOUT ANY WARRANTY; without even the implied warranty of
%     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
%     GNU General Public License for more details.
%
%     You should have received a copy of the GNU General Public License
%     along with HeaRT.  If not, see <http://www.gnu.org/licenses/>.
%

%:- ensure_loaded('heart.pl').
%
% Thermostat Named Types definitions
%
% FIXME:
%  - state all defaults
%  - "basic"? for basic type, any better name?
%
% HINTS
% - named types names should be plural, or general, eg. says
xtype [name: week_days,
       base: symbolic,
       %default -> scale: none,
       %default -> group: root,
       ordered: yes,		% default: no
       domain: [monday,tuesday,wednesday,thursday,friday,saturday,sunday],
%       domain: [monday,tuesday,wednesday,thursday,friday,saturday,sunday],
%      if the domain is oreder and no numbering is used we can still use it, numbering starts with 1
%       domain: [monday/10,tuesday/12,wednesday/15,thursday/28,friday/4,saturday/34,sunday/3],
% domains are FULLY ordered -> unique numbers
       desc: 'some description'
       %NOPE abbrev: [mon,tue,wed,thr,fri,sat,sun]
      ]. 
xtype [name: type_of_day,
       base: symbolic,
       domain: [weekend,workday]
      ].
%xtype [name: month_days,
%       base: numeric,
%       domain: [1 to 31]
%       ].
xtype [name: hours,
       base: numeric,
       domain: [0 to 23]
       ].
xtype [name: biz_hours,
       base: symbolic,
       domain: [during_bizhours,not_bizhours]
      ].
xtype [name: months,
       base: symbolic,
       domain: [january,february,march,april,may,june,july,august,september,october,november,december],
       ordered: yes
      ].
xtype [name: seasons,
       base: symbolic,
       domain: [spring,summer,autumn,winter],
       ordered: yes
      ].
xtype [name: 'Temperature',
       base: numeric,
       %scale: none,
       domain: [0 to 30]
      ].

xtpgr [name:   'A General Date',
       abbrev: 'Date',
       types:  [hours,months]
      ].

%
% Thermostat Attribute definitions
%
% FIXME:
%  - state all defaults + domains
%xattr [name:  STRING, % unique name
%       class: simple|general
%       type:  STRING, % valid type name!
%       comm:  in|out|inter|comm,
%       desc:  STRING, % optional
%       abbrev: STRING % optional
%      ].

xattr [name:  day,
       class: simple,
       type:  week_days,
       comm:  in,
	   callback: io_ask_att(day)
	   ].
xattr [name:  hour,
       class: simple,
       type:  hours,
       comm:  in,
	   callback: io_ask_att(hour)
	   ].
xattr [name:  today,
       class: simple,
       type:  type_of_day,
       comm:  inter].
xattr [name:  operation,
       class: simple,
       type:  biz_hours,
       comm:  inter
      ].
xattr [name:  month,
       class: simple,
       type:  months,
       comm:  in,
       callback: io_ask_att(month)
      ].
xattr [name:  season,
       class: simple,
       type:  seasons,
       comm:  inter].
xattr [name:  therm_set,    %mandatory!
       class: simple,       %mandatory!
       type: 'Temperature', %mandatory!
       comm: out,            %mandatory!
       callback: io_tell_att(therm_set)
%      callback: 'write_att(therm_set).'      
       % default = 
       % default = callback: none,
       % default = abbrev: none,
       % default = desc: none
      ].
%xattr [name: '',
%       class: ,
%       type:  ,
%       comm:  ].

% api:
%  add attribute
%  add type

xatgr [name:   'A General Date',
       abbrev: 'Date',
       types:  [date,time]
      ].

% null in state!
% saving trajectory mode

xschm ms: [month] ==> [season].
xschm dt: [day] ==> [today].
xschm th: [today,hour] ==> [operation].
xschm os: [operation,season] ==> [therm_set].
xschm aa: [season] ==> [day].
%NIY: os/'desc' handling

% xrule syntax:
% xrule TableID/RuleID:
%  [Att1 ALSVOP1 Val1,
%   Att2 ALSVOP2 Val2,
%    . . .
%   Attn ALSVOPn Valn]
%  ==>
%  [AttX set ValX,
%    . . .
%   AttY set ExprY] % settheoretic or arithm in case on numeric atts
%  **>
%   [some_registered_action(Att1,AttN), % with legal (see scheme!) attributes
%    prolog_built_in_pred]
%  :DestTableId/DestRuleId. % optional, can also be just :DestTableId. (rule2table link)
xrule aa/1:
  [season eq spring]
  ==>
  [day set friday].
xrule aa/2:
  [season eq autumn]
  ==>
  [day set sunday].
xrule aa/3:
  [season eq winter]
  ==>
  [day set thursday].
xrule aa/4:
  [season eq winter]
  ==>
  [day set monday].
  
xrule aa/5:
  [season eq winter]
  ==>
  [day set monday].
  
  
xrule ms/1:
  [month in [january,february,december]]
  ==>
  [season set summer].
%xrule ms/2:
%  [month in [march,april,may]]
%  ==>
%  [season set autumn]
%  :os.
xrule ms/2:
  [month in [9,10]]
  ==>
  [season set winter]
  :os.
xrule ms/3:
  [month in [june,july,august]]
  ==>
  [season set winter]
%  **>
  :os/3.
xrule ms/4:
  [month in [9,10,11]] %in [september,october,november]]
  ==>
  [season set winter]
  :os.
%% agatkowe
%xrule ms/5:[month eq september] ==> [season set autumn].

xrule dt/1:
  [day in [monday,tuesday,wednesday,thursday,friday]]
  % FIXME: in case of general atts w/ ordered domain it should be possible to write
  % [mon to fri] as <mon,fri> FIXME how to support <,) and (,> ???
  ==>
  [today set workday].%,
%   today set ah].
%  **>
%  [kot,ma,ale].
%xrule dt/2:
%  [day in [saturday,sunday]]
%  ==>
%  [today set weekend].
  
xrule th/1:
  [today eq workday,
   hour  gt 17]
  ==>
  [operation set not_bizhours].
xrule th/2:
  [today eq weekend,
   hour  eq any]
  ==>
  [operation set not_bizhours].
xrule th/3:
  [today eq workday,
   hour  lt 3]
  ==>
  [operation set not_bizhours].
xrule th/4:
  [today eq workday,
   hour  in [9 to 17]]
  ==>
  [operation set during_bizhours].
xrule th/5:
  [today eq workday,
   hour  lt 3]
  ==>
  [operation set not_bizhours].
xrule os/1:
  [operation eq not_bizhours,
   season eq summer]
  ==>
  [therm_set set 27].
xrule os/2:
  [operation eq during_bizhours,
   season eq summer]
  ==>
  [therm_set set 24].
xrule os/3:
  [operation eq not_bizhours,
   season eq spring]
  ==>
  [therm_set set 15].
xrule os/4:
  [operation eq during_bizhours,
   season eq spring]
  ==>
  [therm_set set 20].
xrule os/5:
  [operation eq during_bizhours,
   season eq winter]
  ==>
  [therm_set set 18].
xrule os/6:
  [operation eq not_bizhours,
   season eq winter]
  ==>
  [therm_set set 14].
xrule os/7:
  [operation eq not_bizhours,
   season eq autumn]
  ==>
  [therm_set set 16].
xrule os/8:
  [operation eq during_bizhours,
   season eq autumn]
  ==>
  [therm_set set 20].

%FIXME three letters alsv operators

xstat s1: [day,'monday'].
xstat s1: [hour,13].
xstat s1: [month,'january'].

xstat s2: [day,sunday].
xstat s2: [hour,8].
xstat s2: [month,'march'].

xstat s3: [day,tuesday].
xstat s3: [hour,19].
xstat s3: [month,'march'].

go:- go1.
go1:- gox(s1,[ms,dt,th,os]).
go2:- gox(s2,[ms,dt,th,os]).
go3:- gox(s3,[ms,dt,th,os]).
goio1 :- goxio([ms,dt,th,os]).
