%/**
%* Wstepna sciezka zawierajaca Pellet
%* Skonfigurowanie faktow 'katalog' jako dynamicznych umozliwia modyfikacje sciezki zawierajacej prolog  
%*/

:- dynamic(katalog/1).
katalog('/FIXME/pellet-2.0.0/').

%/**
%* Procedura konfiguracyjna, na razie umozliwia tylko ustawienie katalogu startowego pelleta
%*/

config :-
nl,
write('Podaj sciezke dostepu Pelleta:'),
nl,
write('Wpisz d jako domyslna'),
nl,
write('Sciezka(kropka na koncu): '),
read(Input),
sciezka(Input).

sciezka(d) :-
retractall(katalog(_)),
assert(katalog('/FIXME/pellet-2.0.0/')).

sciezka(Input) :-
retractall(katalog(_)),
%retract(katalog/1),
assert(katalog(Input)).

%/** Procedury umozliwiajace wywolanie polecen Pelleta z Prologu
%* mozliwe rozwiniecie - zapis wyjscia Pelleta do zmiennej
%*/

pellet_classify(Ontologia) :-
katalog(X),
concat(X,'pellet.sh classify ',Polecenie),
concat(Polecenie,Ontologia,Polecenie2),
tell(pipe(Polecenie2)),
told.

pellet_consistency(Ontologia) :-
katalog(X),
concat(X,'pellet.sh consistency ',Polecenie),
concat(Polecenie,Ontologia,Polecenie2),
tell(pipe(Polecenie2)),
told.


pellet_explain(Ontologia) :-
katalog(X),
concat(X,'pellet.sh explain ',Polecenie),
concat(Polecenie,Ontologia,Polecenie2),
tell(pipe(Polecenie2)),
told.


pellet_extract(Ontologia) :-
katalog(X),
concat(X,'pellet.sh extract ',Polecenie),
concat(Polecenie,Ontologia,Polecenie2),
tell(pipe(Polecenie2)),
told.

