%/**
%* Wstepna sciezka zawierajaca Pellet
%* Skonfigurowanie faktow 'katalog' jako dynamicznych umozliwia modyfikacje sciezki zawierajacej prolog  
%*/

:- dynamic(katalog/1).
katalog('/FIXME/pellet-2.0.0/').

%/**
%* Procedura konfiguracyjna, na razie umozliwia tylko ustawienie katalogu startowego pelleta
%*/

config :-
nl,
write('Podaj sciezke dostepu Pelleta:'),
nl,
write('Wpisz d jako domyslna'),
nl,
write('Sciezka(kropka na koncu): '),
read(Input),
sciezka(Input).

sciezka(d) :-
retractall(katalog(_)),
assert(katalog('/FIXME/pellet-2.0.0/')).

sciezka(Input) :-
retractall(katalog(_)),
%retract(katalog/1),
assert(katalog(Input)).

help :-
tell(pipe('./pellet.sh help')),
told.


/*
Pellet_command umozliwia wywolanie odpowiedniego polecenia Pelleta z poziomu Proglogu w trybie wsadowym.
Mozliwe parametry atrybutu Polecenie:
-classify
-consistency
-explain
-extract

*/

pellet_command(Polecenie,Ontologia) :- 
katalog(X),
concat(X,'pellet.sh ',Sklej1),
concat(Sklej1,Polecenie,Sklej2),
concat(Sklej2,' ',Sklej3),
concat(Sklej3, Ontologia,Sklej4),
tell(pipe(Sklej4)),
told.

pellet_command_detailed(Polecenie, Ontologia) :-
katalog(X),
concat(X,'pellet.sh ',Sklej1),
concat(Sklej1,Polecenie,Sklej2),
concat(Sklej2,' -v ',Sklej3),
concat(Sklej3, Ontologia,Sklej4),
tell(pipe(Sklej4)),
told.

/*
Pellet_SPARQL umozliwia wykonanie wnioskowania w ontologii na podstawie pliku z zapytaniem wykonanym w SPARQL. W wersji z trzema atrybutami, mozliwe jest rowniez podanie formatu eksportu
*/

pellet_SPARQL(Zapytanie,Ontologia) :- 
katalog(X),
concat(X,'pellet.sh query -q ',Sklej1),
concat(Sklej1,Zapytanie,Sklej2),
concat(Sklej2,' ',Sklej3),
concat(Sklej3, Ontologia,Sklej4),
tell(pipe(Sklej4)),
told.

pellet_SPARQL_detailed(Zapytanie,Ontologia) :- 
katalog(X),
concat(X,'pellet.sh query -q ',Sklej1),
concat(Sklej1,Zapytanie,Sklej2),
concat(Sklej2,' -v ',Sklej3),
concat(Sklej3, Ontologia,Sklej4),
tell(pipe(Sklej4)),
told.

pellet_SPARQL_export(Zapytanie,Ontologia,Eksport) :- 
katalog(X),
concat(X,'pellet.sh query -o ',Sklej1),
concat(Sklej1,Eksport,Sklej2),
concat(Sklej2,' -q ',Sklej3),
concat(Sklej3, Zapytanie,Sklej4),
concat(Sklej4,' ',Sklej5),
concat(Sklej5, Ontologia,Sklej6),
tell(pipe(Sklej6)),
told.
